using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;   // added for DllImport

namespace buffSrv
{ 
    public partial class FORM_server : Form
    {
        
        [DllImport("TBufferedSrv.dll")]
        private static extern short AttachServer(string srvExportName, string srvEQPname, int ndevices);
        [DllImport("TBufferedSrv.dll")]
        private static extern short RegisterDeviceName(string deviceName, short devIndex);
               
        [DllImport("c:\\tine\\system32\\tinesrv32.dll")]
        public static extern int UTIME();

        Property readTime;
        Property addInts;

        private int PropertyAddIntsCnt  = 0;
        public FORM_server()
        {
            InitializeComponent();
        }

        private void FORM_server_Load(object sender, EventArgs e)
        {
            int status;
            log("started");

            status = AttachServer("CHshServer", "CHshEq", 1);          
            log("AttachServer " + (status != 0 ? "failed: " + status.ToString() : "OK")); 
                     
            RegisterDeviceName("Dev1", 0);
            
            readTime = new Property("readTime", "read unix time", 1, Property.CF_INT4 );
            addInts = new Property("addInts", "add two integers", 2, Property.CF_INT4, 1, Property.CF_INT4);

            readTime.register();
            addInts.register();

            log("attachCallback " + (addInts.attachCallback (Callback_addInts ) == 0 ? "failed: " + status.ToString() : "OK"));             
        }

     
        private void Callback_addInts()
        {
            int[] data = new int[2];
                     
            LABEL_propertyCallCnt.Text = (++PropertyAddIntsCnt).ToString();
            if ( addInts.pullData("Dev1", data ) != 0) log("error: pullData");
            else log("args: " + data[0] + ", " + data[1]);
            data[0] += data[1];
            addInts.pushData("Dev1", data, 1);
        }

        private void log(string text)
        {                       
            DateTime now = DateTime.Now;

            LISTBOX_log.Items.Add(now.Hour.ToString() 
                              + ":" + now.Minute.ToString() + ":" 
                              + now.Second.ToString() +" > " +text);
            LISTBOX_log.SetSelected(LISTBOX_log.Items.Count-1, true);
        }

        private void TIMER_refreshData_Tick(object sender, EventArgs e)
        {
            int[] data = new int[1];
            data[0] = UTIME();
            readTime.pushData("Dev1", data, 1);
        }
        
    }
}